<?php

class RP_Connection_Factory
{

    /**
     *
     * @param class RP_Credentials $credentials
     * @return mysqli
     */
    static public function get_connection($credentials)
    {
        //$new_link = true;

        $conn = new mysqli($credentials->hostname,
            $credentials->dbuser,
            $credentials->dbpassword,
            $credentials->dbname);
        /*
         * This is the "official" OO way to do it,
         * BUT $connect_error was broken until PHP 5.2.9 and 5.3.0.
         */
        if ($conn->connect_error) {
            die('Connect Error (' . $conn->connect_errno . ') '
                . $conn->connect_error);
        }

        mysqli_set_charset($conn, 'utf8');

        return $conn;
    }

    /**
     *
     * @param mysqli $connection
     */
    static public function close($connection)
    {
        mysqli_close($connection);
    }
}

?>
